(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["provideMulti"] = factory();
	else
		root["provideMulti"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports) {

	"use strict";

	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	exports.default = provideMulti;

	function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

	function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

	function provideMulti(props) {
	  var _constants;

	  var name = props.name;
	  var provider = props.provider;
	  var actionTypes = props.actionTypes;
	  var initialState = props.initialState;


	  var properName = name[0].toUpperCase() + name.substring(1);
	  var capitalName = name.toUpperCase();
	  var INITIAL_STATE = [];

	  var ADD = "ADD_" + capitalName;
	  var REMOVE = "REMOVE_" + capitalName;
	  var constants = (_constants = {}, _defineProperty(_constants, ADD, ADD), _defineProperty(_constants, REMOVE, REMOVE), _constants);

	  var actions = {};
	  var reducers = {};
	  var reduceIndexed = function reduceIndexed(reducer, actionTypes) {
	    var reduced = function reduced() {
	      var state = arguments.length <= 0 || arguments[0] === undefined ? INITIAL_STATE : arguments[0];
	      var action = arguments[1];

	      if (actionTypes[action.type]) {
	        if (action.index >= 0 && action.index < state.length) {
	          state = [].concat(_toConsumableArray(state.slice(0, action.index)), [reducer(state[action.index], action)], _toConsumableArray(state.slice(action.index + 1)));
	        }
	        return state;
	      }
	      switch (action.type) {
	        case ADD:
	          return [].concat(_toConsumableArray(state), [initialState]);
	        case REMOVE:
	          if (state.length == 0) {
	            return state;
	          }
	          return state.slice(0, state.length - 1);
	      }
	      return state;
	    };
	    return reduced;
	  };

	  var bindIndexToDispatchedAction = function bindIndexToDispatchedAction(actionCreator, index) {
	    return function (dispatch, getState) {
	      return function () {
	        var action = Object.assign(actionCreator.apply(undefined, arguments), { index: index });
	        dispatch(action);
	      };
	    };
	  };

	  var _iteratorNormalCompletion = true;
	  var _didIteratorError = false;
	  var _iteratorError = undefined;

	  try {
	    var _loop = function _loop() {
	      var key = _step.value;

	      actions[key] = function (index) {
	        return bindIndexToDispatchedAction(provider.actions[key], index);
	      };
	    };

	    for (var _iterator = Object.keys(provider.actions)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
	      _loop();
	    }
	  } catch (err) {
	    _didIteratorError = true;
	    _iteratorError = err;
	  } finally {
	    try {
	      if (!_iteratorNormalCompletion && _iterator.return) {
	        _iterator.return();
	      }
	    } finally {
	      if (_didIteratorError) {
	        throw _iteratorError;
	      }
	    }
	  }

	  ;

	  var _iteratorNormalCompletion2 = true;
	  var _didIteratorError2 = false;
	  var _iteratorError2 = undefined;

	  try {
	    for (var _iterator2 = Object.keys(provider.reducers)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
	      var _key = _step2.value;

	      reducers[_key + "Multi"] = reduceIndexed(provider.reducers[_key], actionTypes);
	    }
	  } catch (err) {
	    _didIteratorError2 = true;
	    _iteratorError2 = err;
	  } finally {
	    try {
	      if (!_iteratorNormalCompletion2 && _iterator2.return) {
	        _iterator2.return();
	      }
	    } finally {
	      if (_didIteratorError2) {
	        throw _iteratorError2;
	      }
	    }
	  }

	  var addActionKey = "add" + properName;
	  var removeActionKey = "remove" + properName;
	  actions[addActionKey] = function () {
	    return { type: ADD };
	  };
	  actions[removeActionKey] = function () {
	    return { type: REMOVE };
	  };

	  return {
	    actions: actions,
	    reducers: reducers,
	    constants: constants
	  };
	}

/***/ }
/******/ ])
});
;